package co.ab180.airbridge.flutter.utility

import android.content.Context
import co.ab180.airbridge.AirbridgeConfig
import io.flutter.FlutterInjector

fun AirbridgeConfig.Builder.setFromAirbridgeJSON(context: Context): AirbridgeConfig.Builder {
    val loader = FlutterInjector.instance().flutterLoader()
    val json = loader.loadJsonAsset("assets/airbridge.json", context)

    json?.optAsJsonObject?.let { data ->
        data.optAsJsonPrimitive("sessionTimeoutSeconds")?.optAsLong?.let {
            setSessionTimeoutSeconds(it)
        }
        data.optAsJsonPrimitive("autoStartTrackingEnabled")?.optAsBoolean?.let {
            setAutoStartTrackingEnabled(it)
        }
        data.optAsJsonPrimitive("userInfoHashEnabled")?.optAsBoolean?.let {
            setUserInfoHashEnabled(it)
        }
        data.optAsJsonPrimitive("trackAirbridgeLinkOnly")?.optAsBoolean?.let {
            setTrackAirbridgeLinkOnly(it)
        }
        data.optAsJsonPrimitive("locationCollectionEnabled")?.optAsBoolean?.let {
            setLocationCollectionEnabled(it)
        }
        data.optAsJsonPrimitive("facebookDeferredAppLinkEnabled")?.optAsBoolean?.let {
            setFacebookDeferredAppLinkEnabled(it)
        }
    }

    return this
}