package co.ab180.airbridge.flutter.utility

import co.ab180.airbridge.Airbridge

fun Airbridge.trackEvent(category: String, option: Map<*, *>?) {
    Airbridge.trackEvent(
        category = category,
        action = option?.get("action") as? String,
        label = option?.get("label") as? String,
        value = (option?.get("value") as? Number)?.toFloat(),
        customAttributes = (option?.get("customAttributes") as? Map<*, *>)?.let { attributesMap(it) },
        semanticAttributes = (option?.get("semanticAttributes") as? Map<*, *>)?.let { attributesMap(it) }
    )
}

private fun attributesMap(map: Map<*, *>): Map<String, Any> {
    val attributesMap = HashMap<String, Any>()

    map.entries.forEach {
        (it.key as? String)?.let { key ->
            it.value?.let { value ->
                attributesMap.put(key, value)
            }
        }
    }

    return attributesMap
}