package co.ab180.airbridge.flutter.utility

import android.content.Context
import co.ab180.dependencies.com.google.gson.JsonElement
import co.ab180.dependencies.com.google.gson.JsonParser
import io.flutter.embedding.engine.loader.FlutterLoader
import java.lang.Exception

fun FlutterLoader.loadJsonAsset(name: String, context: Context): JsonElement? {
    val path = this.getLookupKeyForAsset(name)
    val content = try { context.assets.open(path).reader().readText() } catch (_: Exception) { null }

    return try { JsonParser.parseString(content) } catch (_: Exception) { null }
}