import UIKit
import Flutter
import airbridge_flutter_sdk
import AppTrackingTransparency

@UIApplicationMain
@objc class AppDelegate: FlutterAppDelegate {
    override func application(
        _ application: UIApplication,
        didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]?
    ) -> Bool {
        if #available(iOS 14, *) {
            ATTrackingManager.requestTrackingAuthorization { status in }
        }
        
        AirbridgeFlutter.initSDK(appName: "abrfl",
                                 appToken: "67b4ad7fa85d46499cb2c4ad952a87ef",
                                 withLaunchOptions: launchOptions)
        
        GeneratedPluginRegistrant.register(with: self)
        
        return super.application(application, didFinishLaunchingWithOptions: launchOptions)
    }
    
    override func application(
        _ application: UIApplication,
        continue userActivity: NSUserActivity,
        restorationHandler: @escaping ([UIUserActivityRestoring]?) -> Void
    ) -> Bool {
        if let universalLink = userActivity.webpageURL {
            AirbridgeFlutter.deeplink.handleUniversalLink(universalLink)
        }
        
        return true
    }
    
    override func application(_ app: UIApplication, open url: URL, options: [UIApplication.OpenURLOptionsKey : Any] = [:]) -> Bool {
        AirbridgeFlutter.deeplink.handleURLSchemeDeeplink(url)
        
        return true
    }
}
