import 'package:flutter/material.dart';

import 'button.dart';

class SettingRow extends StatelessWidget {
  final Widget child;
  final String status;
  final Color backColor;
  final Color textColor;
  final TextAlign textAlign;
  final void Function() onPressed;

  SettingRow({
    required this.child,
    required this.status,
    required this.backColor,
    required this.textColor,
    this.textAlign = TextAlign.center,
    required this.onPressed,
  });

  @override
  Widget build(BuildContext context) {
    return Row(
      children: [
        Expanded(
          child: child,
        ),
        SizedBox(
          width: 120,
          child: Button(
            status,
            backColor: backColor,
            textColor: textColor,
            textAlign: textAlign,
            onPressed: onPressed,
          ),
        ),
      ],
    );
  }
}