class Storage {
  static Map<String, dynamic> _map = Map();
  static Map<String, List<Function>> _onSets = Map();

  static void set(String key, dynamic object) {
    if (_onSets[key] != null) {
      _onSets[key]?.forEach((function) => function(object));
    }

    _map[key] = object;
  }

  static dynamic get(String key) {
    return _map[key];
  }

  static addOnSet(String key, Function callback) {
    if (_onSets[key] == null) {
      _onSets[key] = [];
    }

    _onSets[key]?.add(callback);
  }

  static removeOnSet(String key, Function callback) {
    if (_onSets[key] == null) {
      return;
    }

    _onSets[key]?.remove(callback);
  }
}