import 'package:airbridge_flutter_sdk_example/basic/component/button_grid.dart';
import 'package:airbridge_flutter_sdk_example/basic/utility/storage.dart';

import 'package:flutter/material.dart';

import 'package:airbridge_flutter_sdk/airbridge_flutter_sdk.dart';

class IDSettingGrid extends StatefulWidget {
  @override
  State<StatefulWidget> createState() {
    return _State();
  }
}

class _State extends State<IDSettingGrid> {
  late User user;

  @override
  void initState() {
    super.initState();

    user = Storage.get('user') ?? User();
    setState(() {});
  }

  @override
  Widget build(BuildContext context) {
    return Column(
            children: [
              ButtonGrid(
                width: 3,
                backColor: Colors.grey.shade200,
                textColor: Colors.grey.shade600,
                datas: [
                  ButtonData(user.id ?? '', (){}),
                  ButtonData(user.email ?? '', (){}),
                  ButtonData(user.phone ?? '', (){}),
                ],
              ),
              ButtonGrid(
                width: 3,
                backColor: Colors.green,
                textColor: Colors.white,
                datas: [
                  ButtonData('signIn', (){
                    setUser1();
                    String category = 'signIn';
                    Airbridge.trackEvent(
                      AirbridgeCategory.SIGN_IN,
                      AirbridgeEventOption(
                        action: '$category action',
                        label: '$category label',
                        value: 1111
                    ));
                  }),
                  ButtonData('signOut', (){
                    setUserEmpty();
                    String category = 'signOut';
                    Airbridge.trackEvent(
                      AirbridgeCategory.SIGN_OUT,
                      AirbridgeEventOption(
                        action: '$category action',
                        label: '$category label'
                    ));
                  }),
                  ButtonData('signUp', (){
                    setUser1();
                    String category = 'signUp';
                    Airbridge.trackEvent(
                      AirbridgeCategory.SIGN_UP,
                      AirbridgeEventOption(
                        action: '$category action',
                        label: '$category label',
                        value: 2222
                    ));
                  }),
                ],
              ),
            ],
          );
  }

  void setUserEmpty() {
    user = User();
    Storage.set('user', user);
    Airbridge.state.setUser(user);
    setState(() {});
  }

  void setUser1() {
    user = User(
        id: 'test',
        email: 'test@ab180.co',
        phone: '000-0000-0000',
        alias: {
          'alias_key1': 'value1',
          'alias_key2': 'value2'
        },
        attributes: {
          'attributes_key2': 3,
          'attributes_key5': 2200000000,
          'attributes_key4': 10.4,
          'attributes_key3': true,
          'attributes_key1': 'value1'
        }
    );
    Storage.set('user', user);
    Airbridge.state.setUser(user);
    setState(() {});
  }
}