import 'dart:collection';

import 'package:flutter/material.dart';
import 'package:flutter_inappwebview/flutter_inappwebview.dart';
import 'package:airbridge_flutter_sdk/airbridge_flutter_sdk.dart';

class InAppWebViewHostPage extends StatefulWidget {
  @override
  _InAppWebViewHostPageState createState() =>
      new _InAppWebViewHostPageState();
}
class _InAppWebViewHostPageState extends State<InAppWebViewHostPage> {

  var webInterface;
  final GlobalKey webViewKey = GlobalKey();

  @override
  Widget build(BuildContext context) {
    webInterface = Airbridge.createWebInterface(
      webToken: '8ec37a00b37a4576a7f8bdf8d5164dd5',
      postCommandFunction: (arg) {
        return """window.flutter_inappwebview.callHandler('postMessage', $arg);"""; 
    });

    return InAppWebView(
      key: webViewKey,
      initialUrlRequest: URLRequest(url: Uri.parse("https://cloudflarepagestest-1jn.pages.dev/")),
      onWebViewCreated: (controller) async {
        controller.addJavaScriptHandler(handlerName: 'postMessage', callback: (args) {
          webInterface.handle(args[0]);
          return args;
        });
      },
      initialUserScripts: UnmodifiableListView<UserScript>([
        UserScript(
          source: webInterface.script, 
          injectionTime: UserScriptInjectionTime.AT_DOCUMENT_START)
      ]),
      onConsoleMessage: (controller, consoleMessage) {
        print(consoleMessage);
      },
    );
  }
}