import 'dart:collection';

import 'package:flutter/material.dart';
import 'package:flutter_inappwebview/flutter_inappwebview.dart';
import 'package:airbridge_flutter_sdk/airbridge_flutter_sdk.dart';

class InAppWebViewPage extends StatefulWidget {
  @override
  _InAppWebViewPageState createState() =>
      new _InAppWebViewPageState();
}
class _InAppWebViewPageState extends State<InAppWebViewPage> {

  var webInterface;
  final GlobalKey webViewKey = GlobalKey();

  @override
  Widget build(BuildContext context) {
    webInterface = Airbridge.createWebInterface(
      webToken: 'webToken_sample',
      postCommandFunction: (arg) {
        return """window.flutter_inappwebview.callHandler('postMessage', $arg);"""; 
    });

    return InAppWebView(
      key: webViewKey,
      initialFile : "assets/sample_flutter_inappwebview.html",
      onWebViewCreated: (controller) async {
        controller.addJavaScriptHandler(handlerName: 'postMessage', callback: (args) {
          webInterface.handle(args[0]);
          return args;
        });
      },
      initialUserScripts: UnmodifiableListView<UserScript>([
        UserScript(
          source: webInterface.script, 
          injectionTime: UserScriptInjectionTime.AT_DOCUMENT_START)
      ]),
      onConsoleMessage: (controller, consoleMessage) {
        print(consoleMessage);
      },
    );
  }
}