extension MapUtility<Key, Value> on Map<Key, Value> {
  void assignOptional(Key key, Value? value) {
    if (value != null) {
      this[key] = value;
    }
  }

  Map<Key, Value> filter(bool allow(Key key, Value value)) {
    Map<Key, Value> map = Map.from(this);
    map.removeWhere((key, value) => !allow(key, value));

    return map;
  }
}